Option Strict Off
Imports System.Runtime.InteropServices

Public Class Form1
    'nderung hier:
    'anstelle einer Textbox wird eine RichTextBox verwendet

    Private Structure SHFILEINFO
        Public hIcon As IntPtr ' : icon 
        Public iIcon As Integer ' : icondex
        Public dwAttributes As Integer ' : SFGAO_ flags
        <MarshalAs(UnmanagedType.ByValTStr, SizeConst:=260)> _
        Public szDisplayName As String
        <MarshalAs(UnmanagedType.ByValTStr, SizeConst:=80)> _
        Public szTypeName As String
    End Structure

    Private Declare Auto Function SHGetFileInfo Lib "shell32.dll" _
    (ByVal pszPath As String, _
    ByVal dwFileAttributes As Integer, _
    ByRef psfi As SHFILEINFO, _
    ByVal cbFileInfo As Integer, _
    ByVal uFlags As Integer) As IntPtr

    Private Const SHGFI_ICON As Integer = &H100
    Private Const SHGFI_SMALLICON As Integer = &H1
    Private Const SHGFI_LARGEICON As Integer = &H0    ' Large icon
    Dim lvLokalImagelist As New ImageList
    Dim sItemText As String

    Public Sub DrawFileIcon(ByVal strName As String)
        'Der Form das entsprechende Icon zuweisen!

        'funktioniert leider nur beim Laden und bei einer Grennderung der Form
        'der Versuch das entsprechende "File-Icon" schon beim Speichern einer Datei
        'ohne Grennderung sich in der Form anzeigen zu lassen haben bisher leider nicht funktioniert
        '(hab noch nicht die richtige Methode gefunden)
        Dim shInfo As New SHFILEINFO
        Dim hIcon As IntPtr = SHGetFileInfo(strName, 0, shInfo, Marshal.SizeOf(shInfo), SHGFI_ICON Or SHGFI_SMALLICON Or SHGFI_LARGEICON)
        Me.Icon = Drawing.Icon.FromHandle(shInfo.hIcon)

    End Sub

#Region "ToolBar fr die Dokumente in MDIParent1"

    Private Sub ToolDocButtonUpdaten(ByVal FileName As String)
        'fr speichern bzw. speichern unter...
        Try
            Dim sFileName As String = Me.Text
            With MDIParent1.ToolStripDocs.Items
                For i As Integer = 0 To .Count - 1
                    'nach dem "richtigen" ToolStripButton suchen
                    If .Item(i).Tag = Me.Text Then
                        'den Text und die Tag-Eigenschaft entsprechend ndern
                        .Item(i).Text = FileNamekrzen(FileName)
                        .Item(i).Tag = FileName
                        Exit For
                    End If

                Next
            End With

        Catch ex As Exception
            Cursor = Cursors.Default
            MsgBox(ex.Message, MsgBoxStyle.Exclamation, "Fehler")
        End Try

    End Sub

    Private Sub ShowAktivImage()
        Try

            With MDIParent1
                With .ToolStripDocs

                    'nach dem "richtigen" ToolStripButton suchen
                    For i As Integer = 0 To .Items.Count - 1
                        'das ToolStripLabel (Beschriftung: Dokumente) besitzt nur eine "leere" Tag-Eigenschaft
                        If .Items.Item(i).Tag <> "" Then
                            Dim oToolDocButton As ToolStripButton = .Items.Item(i)
                            'wenn die Tag-Eigenschaft gleich dem aktivem Dokument entspricht
                            If .Items.Item(i).Tag = Me.Text Then
                                'Image fr aktives Dokument einfgen (Checked-Image)
                                .Items.Item(i).Image = Me.Icon.ToBitmap
                                '.Items.Item(i).Image = FrmMainMDI.ImageListaktDoc.Images.Item(0)
                                oToolDocButton.CheckState = CheckState.Checked
                            Else
                                'Image fr inaktives Dokument einfgen (UnChecked-Image)
                                '.Items.Item(i).Image = FrmMainMDI.ImageListaktDoc.Images.Item(1)
                                oToolDocButton.CheckState = CheckState.Unchecked
                            End If
                        End If
                    Next
                End With
            End With

        Catch ex As Exception

        End Try
    End Sub

    Private Sub RemoveToolStripDocButton(ByVal sFileName As String)
        Try
            'lschen eines einzelnen "Dokument"-Buttons
            With MDIParent1.ToolStripDocs.Items
                For i As Integer = 0 To .Count - 1
                    'nach dem "richtigen" ToolStripButton suchen
                    If .Item(i).Tag = sFileName Then
                        'den "richtigen" ToolStripButton entfernen
                        .Remove(.Item(i))
                        Exit For
                    End If
                Next
            End With

        Catch ex As Exception
            Cursor = Cursors.Default
            MsgBox(ex.Message, MsgBoxStyle.Exclamation, "Fehler")
        End Try
    End Sub

#End Region

    Private Sub Form1_Activated(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Activated
        Call ShowAktivImage()
    End Sub

    Private Sub Form1_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        Dim sFileName As String = Me.Text
        Call RemoveToolStripDocButton(sFileName)
    End Sub

    Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        With Me

            If My.Computer.FileSystem.FileExists(Me.Text) Then
                Call DrawFileIcon(Me.Text)
            Else
                .Icon = .Icon
            End If

            Dim oToolDocButton As New ToolStripButton(FileNamekrzen(Me.Text))
            With oToolDocButton
                .Tag = Me.Text
                .Image = MDIParent1.ImageListaktDoc.Images.Item(0)
                .DisplayStyle = ToolStripItemDisplayStyle.ImageAndText
                .CheckState = CheckState.Checked
                AddHandler oToolDocButton.Click, AddressOf MDIParent1.ToolStripDocButton_Click
            End With
            MDIParent1.ToolStripDocs.Items.Add(oToolDocButton)

        End With
    End Sub

    Private Sub Form1_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Resize
        Try
            With Me
                If .WindowState <> FormWindowState.Minimized Then

                    If My.Computer.FileSystem.FileExists(Me.Text) Then
                        Call DrawFileIcon(Me.Text)
                    Else
                        .Icon = Me.Icon
                    End If

                End If
            End With

        Catch ex As Exception

        End Try
    End Sub
End Class
